Makefile.gcc-plugins 2.5 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768
  1. ifdef CONFIG_GCC_PLUGINS
  2. __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
  3. PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
  4. SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
  5. gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
  6. gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so
  7. gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
  8. ifdef CONFIG_PAX_LATENT_ENTROPY
  9. DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable
  10. endif
  11. ifdef CONFIG_GCC_PLUGIN_SANCOV
  12. ifeq ($(CFLAGS_KCOV),)
  13. # It is needed because of the gcc-plugin.sh and gcc version checks.
  14. gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
  15. ifneq ($(PLUGINCC),)
  16. CFLAGS_KCOV := $(SANCOV_PLUGIN)
  17. else
  18. $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
  19. endif
  20. endif
  21. endif
  22. GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
  23. export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
  24. export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
  25. ifneq ($(PLUGINCC),)
  26. # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
  27. GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
  28. endif
  29. KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
  30. GCC_PLUGIN := $(gcc-plugin-y)
  31. GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
  32. endif
  33. # If plugins aren't supported, abort the build before hard-to-read compiler
  34. # errors start getting spewed by the main build.
  35. PHONY += gcc-plugins-check
  36. gcc-plugins-check: FORCE
  37. ifdef CONFIG_GCC_PLUGINS
  38. ifeq ($(PLUGINCC),)
  39. ifneq ($(GCC_PLUGINS_CFLAGS),)
  40. ifeq ($(call cc-ifversion, -ge, 0405, y), y)
  41. $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
  42. @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
  43. else
  44. @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
  45. endif
  46. endif
  47. endif
  48. endif
  49. @:
  50. # Actually do the build, if requested.
  51. PHONY += gcc-plugins
  52. gcc-plugins: scripts_basic gcc-plugins-check
  53. ifdef CONFIG_GCC_PLUGINS
  54. $(Q)$(MAKE) $(build)=scripts/gcc-plugins
  55. endif
  56. @: